/*Theoretically strip out the internet shortcuts from AOL's .pfc file*/
#include <stdio.h>
#include <stdlib.h>
#include <libgen.h>
#include <unistd.h>
#include <sys/stat.h>

/*macros*/
#define WriteURL(F,S) fprintf(F,"[InternetShortcut]\nURL=%s\n",S)

/*global variables and whatnot*/

/*functions*/
unsigned long RSTypeRead(FILE *in,unsigned long pos,short *type);
unsigned long RSDataPos(FILE *in, unsigned long pos, short *type,unsigned long *z);
unsigned long converto(unsigned char *name,int mode);

/*returns size of RS data chunk.  type is set to the RS chunk type*/
unsigned long RSTypeRead(FILE *in,unsigned long pos,short *type)
{unsigned long x;

 fseek(in,pos+2,SEEK_SET);
 fread(&x,2,1,in);
 if(type!=NULL) *type=x;

 fread(&x,4,1,in);
 return x;}

/*returns position of text values in RS data blocks
  type is set to the type of file, either:
       0001 for folder names, 
       0002 for file names
       414F4C +48+ AOLH chunks
       */
unsigned long RSDataPos(FILE *in, unsigned long pos, short *type,unsigned long *z)
{unsigned long x,size;
 unsigned short y;
 
 /*get size of data and set the kill address*/
 size=RSTypeRead(in,pos,NULL);
 pos+=8;
 size+=pos;
 
 /*get type*/
 fseek(in,pos,SEEK_SET);
 fread(&y,2,1,in);
 if(y==1 || y==2)
   {*type=y;
    fseek(in,pos+0x6E,SEEK_SET);
    fread(z,4,1,in);
    return pos+18;}
 
 y=fgetc(in);
 y=fgetc(in);  /*AOL chunk name*/
 *type=y;
 if(y!='H') return 0;
 
 /*AOLH chunk*/
 fseek(in,pos+4,SEEK_SET);
 fread(&size,4,1,in);   /*size of chunk*/
 size+=pos;             /*kill at this address*/
 /*sift through the microcode for the shortcut path entry*/
 pos+=8;
 while(pos<size)
      {fseek(in,pos,SEEK_SET);
       fread(&y,2,1,in);    /*command*/
       if(y==0x4F41) break;       /*break on AOLF*/
       x=fgetc(in);               /*length of data (actually, type)*/
       pos+=3;
       if(x>4)                    /*string length=5 - also catches 08 command*/
         {fread(&x,4,1,in);
          pos+=4;
          }
       switch(y)                  /*handle data.  Right now, only get 05 strings*/
             {case 05: 
                   *z=x;
                   return pos;
                   break;
              default: pos+=x;
              }
       }
 
 *z=0;
 return 0;}

/*friendly-ups the filename*/
unsigned long converto(unsigned char *name,int mode)
{long x,y,size;

 size=strlen(name);
 y=0;                 /*this backspaces when required*/
 for(x=0;x<size;x++)
    {/*kill non-printable characters - less than 32*/
     if(name[x]<32)
       {y--;
        continue;}
     /*DOS fix - kill all whitespace*/
     if(mode&8)
       {if(!isalnum(name[x]))
          {y--;
           continue;}
        }
     /*limit to alphanumeric on request*/
     if(mode&4)
       {if(ispunct(name[x]))
          {y--;
           continue;}
        }
     /*kill non-ANSI when requested*/
     if(mode&2)
       {if(!isascii(name[x]))
          {y--;
           continue;}
        }
     /*test for Windows unacceptable characters*/
     if(mode&1)
       {if(name[x]=='/' || name[x]=='\\' || name[x]==':' || name[x]=='*' || name[x]=='?' || name[x]=='<' || name[x]=='>' || name[x]=='|' || name[x]=='\"')
          {y--;
           continue;}
        }
     if((x+y)>=0) name[x+y]=name[x];
     }
 
 if((x+y)>=0) name[x+y]=0;
 else name[0]=0;
 /*force DOS filenames*/
 if(mode&8) name[8]=0;
 return x;}


/*main
  open files and whatnot
  
  flag:
default1     limits to Windows filenames: can't use /\:*?<>|"
       2     limits to only ASCII characters (char<7F)
       4     limits to only alpha-numeric values
       8     generate DOS 8 dot 3 filenames
default10    verbose
       20    don't create folders
  */
int main(int argc, char *argv[])
{FILE *in, *out;
unsigned char filename[130],buffer[84];
unsigned long x,z,pos,data,max,flag=0x11,folder[64],count;
unsigned short y,index=0;

for(x=1;x<argc;x++)/*command-line arguments*/
    {if(argv[x][0]=='-' || argv[x][0]=='/')
      {switch(argv[x][1])
             {case 'W': case 'w': flag^=0x1;  break;
              case 'D': case 'd': flag^=0x8;  break;
              case 'U': case 'u': flag^=0x2;  break;
              case 'A': case 'a': flag^=0x4;  break;
              case 'Q': case 'q': flag^=0x10; break;
              case 'F': case 'f': flag^=0x20; break;
              case 'H': case 'h': case '?':
                  printf("\nAOL Internet Shortcut Extractor");
                  printf("\nUsage: %s <filename.pfc> <-A>",basename(argv[0]));
                  printf("\n  /Q, -Q\tDisables on-screen text displays");
                  printf("\n  /F, -F\tURLS only: doesn't create folders");
                  printf("\n  /W, -W\tAllow Windows unfriendly characters /\\\":*?<>|");
                  printf("\n  /D, -D\tCreate DOS 8.3 filenames");
                  printf("\n  /U, -U\tUses only ASCII characters (non-unicode systems)");
                  printf("\n  /A, -A\tUses only alpha-numeric characters (A-Z, 0-9)");
                  printf("\n  /H, -H, or -?\tDisplay this help message");
                  return 0;
              }    
      }
    else strcpy(filename,argv[x]);
    }/*end command-line arguments*/

while (!(in = fopen(filename, "rb"))) {
    printf("\ninput preferance filename (.pfc)? ");
	strcpy(filename,"\0");	
	gets(filename);
    }

/*set current directory as working directory (theoretically)*/
chdir(dirname(filename));

/*get offset to table entry*/
fseek(in,16,SEEK_SET);
fread(&pos,4,1,in);
/*get type and size of this segment to ensure you can grab the data*/
max=RSTypeRead(in,pos,&y);
if(y!=1) {fclose(in); return 1;}

/*set up to loop link extraction*/
max=max+pos+8;   /*size of data + RS thingie + original position*/
count=0;
index=0;
folder[count]=0xFFFFFFFF;
for(pos+=20;pos<max;pos+=8)
   {/*fix directory using index values*/
    count+=2;
    while(count>=folder[index])
         {chdir("..\\");
          index--;
          }
    /*get offset to the text for file or folder*/
    fseek(in,pos,SEEK_SET);
    fread(&x,4,1,in);
    if(!x) break;    /*if entry is 0, you're at the end of the list*/
    
    x=RSDataPos(in,x,&y,&z);
    if(!x) continue;  /*do the next one if address or size are stupid*/
    
    /*create a valid filename*/
    memset(buffer,0,81);
    memset(filename,0,130);
    fseek(in,x,SEEK_SET);
    fread(buffer,1,80,in);
    /*change all filesystem-incompatible characters to something inane*/
    converto(buffer,flag);
    if(flag&0x10) printf("\n%X\t%s\t%s",pos,y>1 ? "link":"folder",buffer);

    if(y==1)                /*folders*/
      {if(flag&0x20) continue;
       sprintf(filename,".\\%s",buffer);
       mkdir(filename);
       if(!chdir(filename))
         {if(z==0) z=folder[index];
          if(z==0) z=0xFFFFFFFF;
          index++;
          folder[index]=z;
          }
       continue;
       }
    else if(y!=2) continue; /*files only.  others I just don't know about*/

    /*open link's file!*/
    strcat(buffer,".url");
    if(!(out=fopen(buffer,"wt"))) continue; /*skip if you can't open output files*/
    
    /*returns position to shortcut path*/
    fseek(in,pos+4,SEEK_SET);
    fread(&x,4,1,in);
    x=RSDataPos(in,x,&y,&z);
    if(!x || !z) 
      {fclose(out);
       remove(buffer);
       continue;}
    fseek(in,x,SEEK_SET);
    fread(filename,1,z,in);
    /*before writting, test if it is an AOL keyword*/
    if(!strncmp(filename,"aol:",4))
      {fclose(out);
       remove(buffer);
       continue;
       }
    /*write the shortcut*/
    WriteURL(out,filename);
    fclose(out);
    }

/*wrap things up*/
fclose(in);
return 0;}
